<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Puzzle</title>
</head>
<body>

	<style>
		.canvas{
			border: solid thin #888;
			width:500px;
			height:500px;
		}

		.canvas-holder{
			margin: auto;
			margin-top:50px;
			width:100%;
			max-width:800px;
			background-color: #eee;
		}

	</style>
	<div class="canvas-holder">
		<canvas class="canvas"></canvas>
	</div>
</body>
</html>

<script>
	
	const canvas = document.querySelector(".canvas");
	const ctx = canvas.getContext('2d');

	canvas.addEventListener('mousemove',mousemoved);
	canvas.addEventListener('mousedown',mousedown);
	window.addEventListener('mouseup',mouseup);

	var mouseIsDown = false;

	function mousemoved(e)
	{
		if(mouseIsDown)
			console.log("mouse moved");
	}

	function mousedown(e)
	{
		mouseIsDown = true;
		console.log("mouse down");
	}

	function mouseup(e)
	{
		mouseIsDown = false;
		console.log("mouse up");
	}

	
</script>